<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task33.30 insert user</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script> 
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script> 
</head>
<body>
    <div class = "container jumbotron">
        <div class = "text-center mb-4">
            <h3>Tạo mới user</h3>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>First Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-firstname" class = "form-control" placeholder="Nhập Firstname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Last Name</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-lastname" class = "form-control" placeholder="Nhập Lastname...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Subject</label>
            </div>
            <div class = "col-sm-8">
                <input id="input-subject" class = "form-control" placeholder="Nhập Subject...">
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Country</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-country" class = "form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="USA">USA</option>
                    <option value="AUS">Australia</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>
        <div class = "row form-group">
            <div class = "col-sm-4">
                <label>Customer Type</label>
            </div>
            <div class = "col-sm-8">
                <select id="select-customer-type" class = "form-control">
                    <option value="Standard">Standard</option>
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                </select>
            </div>
        </div>
        
        <div class = "row form-group">
            <div class = "col-sm-4">

            </div>
            <div class = "col-sm-8">
                <button id = "btn-insert-user" class = "btn btn-success w-25"> Insert user</button>
                <button id = "btn-cancel" class = "btn btn-success w-25"> Hủy bỏ</button>
            </div>
        </div>
        
    </div>
</body>
<script>
     "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    //định nghĩa các biến input trong form
    var gElementFirstName = $("#input-firstname");
    var gElementLastName = $("#input-lastname");
    var gElementSubject = $("#input-subject");
    var gElementCountry = $("#select-country");
    var gElementCustomerType = $("#select-customer-type");
    
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    
    $("#btn-insert-user").click(function(){//hàm xử lý sự kiện update user
        console.log("Insert user click.....");
        //b1: get data from form
        var vUserObject = getFormData();
        //b2: validate
        var vCheck = validateFormData(vUserObject);
        if (vCheck){
            //b3: gọi API update user info
            callAjaxApiAddUser(vUserObject);
        }
    });
    $("#btn-cancel").click(function(){
        onBtnCancelClick();
    });
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnCancelClick(){
        window.location.href = "userList.html";
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    //hàm thu thập dữ liệu trên form
    function getFormData(){
        var vNewUserObj = new Object();
        vNewUserObj.firstname = $(gElementFirstName).val();
        vNewUserObj.lastname = $(gElementLastName).val();
        vNewUserObj.subject = $(gElementSubject).val();
        vNewUserObj.country = $(gElementCountry).val();
        vNewUserObj.customerType = $(gElementCustomerType).val();
        vNewUserObj.registerStatus = "New";
        return vNewUserObj;
    }
    //hàm validate data trên form
    function validateFormData(paramUserObject){
        if (paramUserObject.firstname == "" ||
        paramUserObject.lastname == "" ||
        paramUserObject.subject == "" ||
        paramUserObject.country == "" ||
        paramUserObject.customerType == ""){
            alert ("Thông tin không được để trống");
            return false;
        }
        return true;
    }
    function callAjaxApiAddUser(paramNewUserObject) {
        "use strict";
        var vJsonString = JSON.stringify(paramNewUserObject);
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/",
            type: "POST",
            contentType: "application/json",
            data: vJsonString,
            success: updateUserSuccess,
            error:updateUserError,
        });        
    }
    //xử lý response success
    function updateUserSuccess(paramResponse){
        alert("User Id: " + paramResponse.id + " is added succesfully!");
        //quay lại trang user list
        window.location.href = "userList.html";
        console.log("%cUPDATED INFORMATION: ", "color:orange");
        console.log(paramResponse);
    }
    //xử lý response error
    function updateUserError(paramAjaxContext){
        alert(paramAjaxContext.responseText)
    }
</script>
</html>